<!--
  ~ EVS Client is part of the Gazelle Test Bed
  ~ Copyright (C) 2006-2016 IHE
  ~ mailto :eric DOT poiseau AT inria DOT fr
  ~
  ~ See the NOTICE file distributed with this work for additional information
  ~ regarding copyright ownership.  This code is licensed
  ~ to you under the Apache License, Version 2.0 (the
  ~ "License"); you may not use this file except in compliance
  ~ with the License.  You may obtain a copy of the License at
  ~
  ~   http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~ Unless required by applicable law or agreed to in writing,
  ~ software distributed under the License is distributed on an
  ~ "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
  ~ KIND, either express or implied.  See the License for the
  ~ specific language governing permissions and limitations
  ~ under the License.
  -->

<ui:composition xmlns:h="http://java.sun.com/jsf/html" xmlns:s="http://jboss.org/schema/seam/taglib"
                xmlns:g="http://www.ihe.net/gazelle" xmlns:f="http://java.sun.com/jsf/core"
                xmlns:rich="http://richfaces.org/rich"
                xmlns:a4j="http://richfaces.org/a4j" xmlns:ui="http://java.sun.com/jsf/facelets"
                xmlns="http://www.w3.org/1999/xhtml">
    <!-- This template must be included using a s:decorate element in a <ui:define name="body"> element-->
    <h:form id="globalForm">
        <h:outputText style="display: none;" styleClass="scriptLocalization" value="#{applicationConfiguration.getLocalizationCDAPIDs()}"/>
        <h:outputScript library="jscript" name="checkPid.js"/>
        <a4j:jsFunction name="ontyperejected" actionListener="#{xvalGui.displayInvalidFileTypeMessage()}"/>

        <a4j:outputPanel id="globalDiv">
            <s:div rendered="#{not xvalGui.isValidationDone()}">
                <ui:decorate template="/layout/panels/_panel_title_footer_id.xhtml">
                    <ui:param name="panel_id" value="validatorPanel"/>
                    <ui:define name="panel_title">
                        <h:outputText value="#{messages['net.ihe.gazelle.evs.ValidatorSelection']}"/>
                    </ui:define>

                    <s:div rendered="#{xvalGui.getStandardDescription() != null}">
                        <s:span styleClass="help-block">
                            <g:safehtml value="#{xvalGui.getStandardDescription()}"/>
                        </s:span>
                    </s:div>
                    <s:div id="additionalData">
                        <ui:insert name="additionalInfo"/>
                    </s:div>

                    <s:div id="methodSelectionDecoration" styleClass="form-horizontal">

                        <s:decorate template="/layout/form/_form_field_horizontal_inline.xhtml">
                            <ui:param name="id" value="senddtxt"/>
                            <ui:define name="label">#{messages['net.ihe.gazelle.evs.SelectAValidator']} :</ui:define>
                            <h:selectOneMenu styleClass="form-control gzl-form-control gzl-select-text" id="senddtxt"
                                             value="#{xvalGui.selectedValidatorName}">
                                <f:selectItems
                                        value="#{xvalGui.getValidatorsAsSelectItems()}"
                                        noSelectionLabel="#{messages['gazelle.common.PleaseSelect']}"/>
                                <a4j:ajax event="change" render="loadFilesForm panel_footer_id description_panel"/>
                            </h:selectOneMenu>
                            <s:div id="description_panel" style="width: 90%;"
                            >
                                <s:span styleClass="help-block">
                                    <g:safehtml value="#{xvalGui.getValidationServiceDescription()}"/>
                                </s:span>
                            </s:div>
                        </s:decorate>

                    </s:div>

                    <s:div id="loadFilesForm">
                        <ui:decorate template="/xval/filesDiv.xhtml">
                            <ui:param name="gui" value="#{xvalGui.getInputsGui()}"/>
                        </ui:decorate>

                        <s:div id="uploadFileForm">
                            <ui:decorate template="/layout/popup/_popup_title_footer.xhtml">
                                <ui:param name="popup_id" value="uploadFilePopup"/>
                                <ui:define name="popup_title">#{messages['net.ihe.gazelle.xval.UploadAFileToValidate']}</ui:define>
                                <s:div id="uploadFilePopupContent">
                                    <s:span styleClass="gzl-icon-info ">
                                        <h:outputText
                                                value=" #{messages['net.ihe.gazelle.xval.UploadFilesForInput']} #{xvalGui.inputsGui.selectedInput.referencedObject.keyword} (#{xvalGui.inputsGui.selectedInput.referencedObject.objectType.value})"/>
                                    </s:span>
                                    <s:decorate template="/layout/display/_display.xhtml">
                                        <ui:define name="label">#{messages['net.ihe.gazelle.xval.MinCardinality']}</ui:define>
                                        <h:outputText value="#{xvalGui.inputsGui.selectedInput.minQuantity}"/>
                                    </s:decorate>
                                    <s:decorate template="/layout/display/_display.xhtml">
                                        <ui:define name="label">#{messages['net.ihe.gazelle.xval.MaxCardinality']}</ui:define>
                                        <h:outputText value="#{xvalGui.inputsGui.selectedInput.maxQuantity}"/>
                                    </s:decorate>
                                    <s:decorate template="/layout/display/_display.xhtml">
                                        <ui:define name="label">#{messages['net.ihe.gazelle.xval.NbOfUploadFiles']})</ui:define>
                                        <h:outputText value="#{xvalGui.inputsGui.getSelectedInputHandledObjects().size()}"/>
                                    </s:decorate>
                                    <rich:fileUpload fileUploadListener="#{xvalGui.uploadListener}" id="upload"
                                                     immediateUpload="true" enctype="multipart/form-data"
                                                     disabled="#{not xvalGui.inputsGui.isSelectedInputUploadNeeded()}"
                                                     maxFilesQuantity="#{xvalGui.inputsGui.selectedInput.maxQuantity}"/>
                                </s:div>
                                <ui:define name="popup_footer">
                                    <a4j:commandButton value="#{messages['net.ihe.gazelle.xval.Done']}" oncomplete="jq162('#uploadFilePopup').modal('hide');"
                                                       actionListener="#{xvalGui.inputsGui.setSelectedInput(null)}"
                                                       render="filesTable, filesDiv, :buttons :remoteButtons panel_footer_id"
                                                       styleClass="gzl-btn-green"/>
                                </ui:define>
                            </ui:decorate>
                        </s:div>
                    </s:div>

                    <ui:define name="panel_footer">
                        <s:div id="panel_footer_id">

                            <a4j:commandButton id="validateXvalButton" styleClass="gzl-btn-blue"
                                               value="#{messages['gazelle.evs.client.validate']}"
                                               actionListener="#{xvalGui.validate()}"
                                               oncomplete="
                                               #{xvalResultGui.init(xvalGui.buildAndGetValidationResultDto(), xvalGui.referencedStandard.id)};
                                               if(#{xvalResultGui.sendBackResultToTool()})
                                                 {jq162('#sendBackToCallingTool').modal('show')}
                                               else if (#{xvalResultGui.displayInfoPopup()})
                                                 {jq162('#infoPopup').modal('show')}
                                               else
                                                 {jq162('#sendBackToCallingTool').modal('hide')}"
                                               rendered="#{xvalGui.getInputsGui().areAllInputsWithFiles()}"
                                               render="@form" execute="@form"/>
                            <h:commandLink action="#{xvalGui.downloadWebServiceBody()}" rendered="#{xvalGui.getInputsGui().areAllInputsWithFiles()}">
                                <h:outputText value="#{messages['net.ihe.gazelle.evs.GetXMLWebserviceRequest']}" styleClass="gzl-btn-blue"/>
                            </h:commandLink>

                        </s:div>
                    </ui:define>
                </ui:decorate>

            </s:div>
        </a4j:outputPanel>

        <a4j:outputPanel id="validationDiv">
            <s:div rendered="#{xvalGui.isValidationDone()}">
                <ui:include id="detailedr" src="/xval/report.xhtml">
                    <ui:param name="dd_styleClass" value="gzl-dd-label"/>
                </ui:include>
            </s:div>
        </a4j:outputPanel>


    </h:form>

</ui:composition>
